# -*- coding: utf-8 -*-
import sys
from os import path
import laborejocore as api

JACK_MIDI_IN = True
BARLINES = True
LYRICS = False
DURATION_MOD = 0.15 #0.125 #Bigger means more space between all notes and objects
MIDI_TIMER = 50 #miliseconds. The lower it is the less latency you hear for midi thru. Low values may drag down performance. Try to stay above 10ms.

lilypondbinary = "" #use the default
pdfviewer = "" #use the default

#Shortcuts
shortcuts = {
        #Non-menu
        #Modal Commands
        "1" : "modalcommands.commands.key_one",
        "2" : "modalcommands.commands.key_two",
        "3" : "modalcommands.commands.key_three",
        "4" : "modalcommands.commands.key_four",
        "5" : "modalcommands.commands.key_five",
        "6" : "modalcommands.commands.key_six",
        "7" : "modalcommands.commands.key_seven",
        "8" : "modalcommands.commands.key_eight",
        "9" : "modalcommands.commands.key_nine",
        "0" : "modalcommands.commands.key_zero",

        "Shift+1" : "modalcommands.commands.key_shift_one",
        "Shift+2" : "modalcommands.commands.key_shift_two",
        "Shift+3" : "modalcommands.commands.key_shift_three",
        "Shift+4" : "modalcommands.commands.key_shift_four",
        "Shift+5" : "modalcommands.commands.key_shift_five",
        "Shift+6" : "modalcommands.commands.key_shift_six",
        "Shift+7" : "modalcommands.commands.key_shift_seven",
        "Shift+8" : "modalcommands.commands.key_shift_eight",
        "Shift+9" : "modalcommands.commands.key_shift_nine",
        "Shift+0" : "modalcommands.commands.key_shift_zero",

        #"Alt+1" : "modalcommands.commands.key_alt_one",
        #"Alt+2" : "modalcommands.commands.key_alt_two",
        #"Alt+3" : "modalcommands.commands.key_alt_three",
        #"Alt+4" : "modalcommands.commands.key_alt_four",
        #"Alt+5" : "modalcommands.commands.key_alt_five",
        #"Alt+6" : "modalcommands.commands.key_alt_six",
        #"Alt+7" : "modalcommands.commands.key_alt_seven",
        #"Alt+8" : "modalcommands.commands.key_alt_eight",
        #"Alt+9" : "modalcommands.commands.key_alt_nine",
        #"Alt+0" : "modalcommands.commands.key_alt_zero",

        "Alt+Shift+1" : "modalcommands.commands._key_alt_shift_one",
        "Alt+Shift+2" : "modalcommands.commands._key_alt_shift_two",
        "Alt+Shift+3" : "modalcommands.commands._key_alt_shift_three",
        "Alt+Shift+4" : "modalcommands.commands._key_alt_shift_four",
        "Alt+Shift+5" : "modalcommands.commands._key_alt_shift_five",
        "Alt+Shift+6" : "modalcommands.commands._key_alt_shift_six",
        "Alt+Shift+7" : "modalcommands.commands._key_alt_shift_seven",
        "Alt+Shift+8" : "modalcommands.commands._key_alt_shift_eight",
        "Alt+Shift+9" : "modalcommands.commands._key_alt_shift_nine",
        "Alt+Shift+0" : "modalcommands.commands._key_alt_shift_zero",

        #Keypad Modal Commands
        "QtCore.Qt.KeypadModifier+QtCore.Qt.Key_1" : "modalcommands.commands.keypad_one",
        "QtCore.Qt.KeypadModifier+QtCore.Qt.Key_2" : "modalcommands.commands.keypad_two",
        "QtCore.Qt.KeypadModifier+QtCore.Qt.Key_3" : "modalcommands.commands.keypad_three",
        "QtCore.Qt.KeypadModifier+QtCore.Qt.Key_4" : "modalcommands.commands.keypad_four",
        "QtCore.Qt.KeypadModifier+QtCore.Qt.Key_5" : "modalcommands.commands.keypad_five",
        "QtCore.Qt.KeypadModifier+QtCore.Qt.Key_6" : "modalcommands.commands.keypad_six",
        "QtCore.Qt.KeypadModifier+QtCore.Qt.Key_7" : "modalcommands.commands.keypad_seven",
        "QtCore.Qt.KeypadModifier+QtCore.Qt.Key_8" : "modalcommands.commands.keypad_eight",
        "QtCore.Qt.KeypadModifier+QtCore.Qt.Key_9" : "modalcommands.commands.keypad_nine",
        "QtCore.Qt.KeypadModifier+QtCore.Qt.Key_0" : "modalcommands.commands.keypad_zero",

        "QtCore.Qt.KeypadModifier+QtCore.Qt.ShiftModifier+QtCore.Qt.Key_1" : "modalcommands.commands.keypad_shift_one",
        "QtCore.Qt.KeypadModifier+QtCore.Qt.ShiftModifier+QtCore.Qt.Key_2" : "modalcommands.commands.keypad_shift_two",
        "QtCore.Qt.KeypadModifier+QtCore.Qt.ShiftModifier+QtCore.Qt.Key_3" : "modalcommands.commands.keypad_shift_three",
        "QtCore.Qt.KeypadModifier+QtCore.Qt.ShiftModifier+QtCore.Qt.Key_4" : "modalcommands.commands.keypad_shift_four",
        "QtCore.Qt.KeypadModifier+QtCore.Qt.ShiftModifier+QtCore.Qt.Key_5" : "modalcommands.commands.keypad_shift_five",
        "QtCore.Qt.KeypadModifier+QtCore.Qt.ShiftModifier+QtCore.Qt.Key_6" : "modalcommands.commands.keypad_shift_six",
        "QtCore.Qt.KeypadModifier+QtCore.Qt.ShiftModifier+QtCore.Qt.Key_7" : "modalcommands.commands.keypad_shift_seven",
        "QtCore.Qt.KeypadModifier+QtCore.Qt.ShiftModifier+QtCore.Qt.Key_8" : "modalcommands.commands.keypad_shift_eight",
        "QtCore.Qt.KeypadModifier+QtCore.Qt.ShiftModifier+QtCore.Qt.Key_9" : "modalcommands.commands.keypad_shift_nine",
        "QtCore.Qt.KeypadModifier+QtCore.Qt.ShiftModifier+QtCore.Qt.Key_0" : "modalcommands.commands.keypad_shift_zero",

        "QtCore.Qt.KeypadModifier+QtCore.Qt.ControlModifier+QtCore.Qt.Key_1" : "modalcommands.commands.keypad_ctrl_one",
        "QtCore.Qt.KeypadModifier+QtCore.Qt.ControlModifier+QtCore.Qt.Key_2" : "modalcommands.commands.keypad_ctrl_two",
        "QtCore.Qt.KeypadModifier+QtCore.Qt.ControlModifier+QtCore.Qt.Key_3" : "modalcommands.commands.keypad_ctrl_three",
        "QtCore.Qt.KeypadModifier+QtCore.Qt.ControlModifier+QtCore.Qt.Key_4" : "modalcommands.commands.keypad_ctrl_four",
        "QtCore.Qt.KeypadModifier+QtCore.Qt.ControlModifier+QtCore.Qt.Key_5" : "modalcommands.commands.keypad_ctrl_five",
        "QtCore.Qt.KeypadModifier+QtCore.Qt.ControlModifier+QtCore.Qt.Key_6" : "modalcommands.commands.keypad_ctrl_six",
        "QtCore.Qt.KeypadModifier+QtCore.Qt.ControlModifier+QtCore.Qt.Key_7" : "modalcommands.commands.keypad_ctrl_seven",
        "QtCore.Qt.KeypadModifier+QtCore.Qt.ControlModifier+QtCore.Qt.Key_8" : "modalcommands.commands.keypad_ctrl_eight",
        "QtCore.Qt.KeypadModifier+QtCore.Qt.ControlModifier+QtCore.Qt.Key_9" : "modalcommands.commands.keypad_ctrl_nine",
        "QtCore.Qt.KeypadModifier+QtCore.Qt.ControlModifier+QtCore.Qt.Key_0" : "modalcommands.commands.keypad_ctrl_zero",

        "QtCore.Qt.KeypadModifier+QtCore.Qt.AltModifier+QtCore.Qt.Key_1" : "modalcommands.commands.keypad_alt_one",
        "QtCore.Qt.KeypadModifier+QtCore.Qt.AltModifier+QtCore.Qt.Key_2" : "modalcommands.commands.keypad_alt_two",
        "QtCore.Qt.KeypadModifier+QtCore.Qt.AltModifier+QtCore.Qt.Key_3" : "modalcommands.commands.keypad_alt_three",
        "QtCore.Qt.KeypadModifier+QtCore.Qt.AltModifier+QtCore.Qt.Key_4" : "modalcommands.commands.keypad_alt_four",
        "QtCore.Qt.KeypadModifier+QtCore.Qt.AltModifier+QtCore.Qt.Key_5" : "modalcommands.commands.keypad_alt_five",
        "QtCore.Qt.KeypadModifier+QtCore.Qt.AltModifier+QtCore.Qt.Key_6" : "modalcommands.commands.keypad_alt_six",
        "QtCore.Qt.KeypadModifier+QtCore.Qt.AltModifier+QtCore.Qt.Key_7" : "modalcommands.commands.keypad_alt_seven",
        "QtCore.Qt.KeypadModifier+QtCore.Qt.AltModifier+QtCore.Qt.Key_8" : "modalcommands.commands.keypad_alt_eight",
        "QtCore.Qt.KeypadModifier+QtCore.Qt.AltModifier+QtCore.Qt.Key_9" : "modalcommands.commands.keypad_alt_nine",
        "QtCore.Qt.KeypadModifier+QtCore.Qt.AltModifier+QtCore.Qt.Key_0" : "modalcommands.commands.keypad_alt_zero",

        "QtCore.Qt.KeypadModifier+QtCore.Qt.AltModifier+QtCore.Qt.ShiftModifier+QtCore.Qt.Key_1" : "modalcommands.commands.keypad_alt_shift_one",
        "QtCore.Qt.KeypadModifier+QtCore.Qt.AltModifier+QtCore.Qt.ShiftModifier+QtCore.Qt.Key_2" : "modalcommands.commands.keypad_alt_shift_two",
        "QtCore.Qt.KeypadModifier+QtCore.Qt.AltModifier+QtCore.Qt.ShiftModifier+QtCore.Qt.Key_3" : "modalcommands.commands.keypad_alt_shift_three",
        "QtCore.Qt.KeypadModifier+QtCore.Qt.AltModifier+QtCore.Qt.ShiftModifier+QtCore.Qt.Key_4" : "modalcommands.commands.keypad_alt_shift_four",
        "QtCore.Qt.KeypadModifier+QtCore.Qt.AltModifier+QtCore.Qt.ShiftModifier+QtCore.Qt.Key_5" : "modalcommands.commands.keypad_alt_shift_five",
        "QtCore.Qt.KeypadModifier+QtCore.Qt.AltModifier+QtCore.Qt.ShiftModifier+QtCore.Qt.Key_6" : "modalcommands.commands.keypad_alt_shift_six",
        "QtCore.Qt.KeypadModifier+QtCore.Qt.AltModifier+QtCore.Qt.ShiftModifier+QtCore.Qt.Key_7" : "modalcommands.commands.keypad_alt_shift_seven",
        "QtCore.Qt.KeypadModifier+QtCore.Qt.AltModifier+QtCore.Qt.ShiftModifier+QtCore.Qt.Key_8" : "modalcommands.commands.keypad_alt_shift_eight",
        "QtCore.Qt.KeypadModifier+QtCore.Qt.AltModifier+QtCore.Qt.ShiftModifier+QtCore.Qt.Key_9" : "modalcommands.commands.keypad_alt_shift_nine",
        "QtCore.Qt.KeypadModifier+QtCore.Qt.AltModifier+QtCore.Qt.ShiftModifier+QtCore.Qt.Key_0" : "modalcommands.commands.keypad_alt_shift_zero",

        "QtCore.Qt.KeypadModifier+QtCore.Qt.AltModifier+QtCore.Qt.ControlModifier+QtCore.Qt.Key_1" : "modalcommands.commands.keypad_alt_ctrl_one",
        "QtCore.Qt.KeypadModifier+QtCore.Qt.AltModifier+QtCore.Qt.ControlModifier+QtCore.Qt.Key_2" : "modalcommands.commands.keypad_alt_ctrl_two",
        "QtCore.Qt.KeypadModifier+QtCore.Qt.AltModifier+QtCore.Qt.ControlModifier+QtCore.Qt.Key_3" : "modalcommands.commands.keypad_alt_ctrl_three",
        "QtCore.Qt.KeypadModifier+QtCore.Qt.AltModifier+QtCore.Qt.ControlModifier+QtCore.Qt.Key_4" : "modalcommands.commands.keypad_alt_ctrl_four",
        "QtCore.Qt.KeypadModifier+QtCore.Qt.AltModifier+QtCore.Qt.ControlModifier+QtCore.Qt.Key_5" : "modalcommands.commands.keypad_alt_ctrl_five",
        "QtCore.Qt.KeypadModifier+QtCore.Qt.AltModifier+QtCore.Qt.ControlModifier+QtCore.Qt.Key_6" : "modalcommands.commands.keypad_alt_ctrl_six",
        "QtCore.Qt.KeypadModifier+QtCore.Qt.AltModifier+QtCore.Qt.ControlModifier+QtCore.Qt.Key_7" : "modalcommands.commands.keypad_alt_ctrl_seven",
        "QtCore.Qt.KeypadModifier+QtCore.Qt.AltModifier+QtCore.Qt.ControlModifier+QtCore.Qt.Key_8" : "modalcommands.commands.keypad_alt_ctrl_eight",
        "QtCore.Qt.KeypadModifier+QtCore.Qt.AltModifier+QtCore.Qt.ControlModifier+QtCore.Qt.Key_9" : "modalcommands.commands.keypad_alt_ctrl_nine",
        "QtCore.Qt.KeypadModifier+QtCore.Qt.AltModifier+QtCore.Qt.ControlModifier+QtCore.Qt.Key_0" : "modalcommands.commands.keypad_alt_ctrl_zero",


        #Non-Modal Commands
        "Alt+1" : "actionClefs",
        "Alt+2" : "actionTime_Signatures",
        "Alt+3" : "actionKey_Signatures",
        "Alt+4" : "actionPerformance_Signature",
        "Alt+5" : "actionTempo_Signature",
        "Alt+6" : "actionInstrument_Change",
        #"Alt+7" : "",
        #"Alt+8" : "",
        #"Alt+9" : "",
        #"Alt+0" : "",


        "Tab" : "api.dotAdd", #This is a duplicate entry. Dot is in twice and the menu version shows "."
        "Shift+Tab" : "api.dotRemove", #This is a duplicate entry. Dot is in twice and the menu version shows "Shift+."

        "F2" : "actionScript",
        "F3" : "actionView_PDF",
        "Shift+F3" : "actionLilypond_Text",

        "F4" : "actionToggle_Insert_Prevailing",

        #F5 Play
        "F8" : "actionMIDI_Note_Entry",

        #Navigation
        "Left" : "api.left",
        "Right" : "api.right",
        "Shift+Left" : "api.selectLeft",
        "Shift+Right" : "api.selectRight",
        "Ctrl+Left" : "api.measureLeft",
        "Ctrl+Right" : "api.measureRight",
        "Ctrl+Shift+Left" : "api.selectMeasureLeft",
        "Ctrl+Shift+Right" : "api.selectMeasureRight",
        "Ctrl+Shift+Up" : "api.selectMeasure",
        "Ctrl+Shift+Down" : "api.selectMeasure",
        "Ctrl+Up" : "api.upOctave",
        "Ctrl+Down" : "api.downOctave",
        "Home" : "api.head",
        "Shift+Home" : "api.selectHead",
        "End" : "api.tail",
        "Shift+End" : "api.selectTail",
        "Up" : "api.up",
        "Down" : "api.down",
        "Page Up" : "api.trackUp",
        "Page Down" : "api.trackDown",
        "Ctrl+Page Up" : "api.trackFirst",
        "Ctrl+Page Down" : "api.trackLast",

        #Basic Modification
        "W" : "actionShift_Up",
        "S" : "actionShift_Down",
        "Shift+W" : "actionShift_Octave_Up",
        "Shift+S" : "actionShift_Octave_Down",

        "Alt+W" : "actionShift_Note_Up",
        "Alt+S" : "actionShift_Note_Down",
        "Alt+Shift+W" : "actionShift_Note_Octave_Up",
        "Alt+Shift+S" : "actionShift_Note_Octave_Down",

        "Return" : "actionAdd_Note_to_Chord",
        "Shift+Return" : "actionAdd_Octave_to_Chord",
        "Shift+Delete" : "actionRemove_Note_from_Chord",

        "-" : "actionSharp",
        "+" : "actionFlat",

        "Escape" : "self.focusOnActiveScore",

        #Menu

        #File
        "Ctrl+O" : "actionOpen",
        "Ctrl+Shift+O" : "actionOpen_as_Template",
        "Ctrl+S" : "actionSave",
        "Ctrl+S" : "actionSave",
        "Ctrl+Shift+S" : "actionSave_As",
        "Ctrl+Shift+S" : "actionSave_As",
        "Ctrl+N" : "actionNew",
        "Ctrl+Q" : "actionQuit",
        "Ctrl+W" : "actionClose",

        #Edit
        "Ctrl+a" : "actionSelect_Track",
        "Ctrl+Shift+a" : "actionSelect_All",
        "Ctrl+i" : "actionInvert_Selection",
        "Space" : "actionClear_Selection",
        "Ctrl+C" : "actionCopy",
        "Ctrl+X" : "actionCut",
        "Ctrl+V" : "actionPaste",
        "Ctrl+Z" : "actionUndo",
        "Ctrl+Shift+Z" : "actionRedo",
        "Delete" : "actionDelete",
        "Ctrl+Shift+V" : "actionPaste_replace_Selection",
        "Backspace" : "actionDelete_Previous",
        "E" : "actionDuplicate",
        "Shift+E" : "actionLink",

        #View
        "Ctrl+E" : "actionTrack_Properties",
        "Ctrl+L" : "actionLyrics",
        "Ctrl+M" : "actionMinimap",
        "Ctrl+Shift++" : "actionWiden",
        "Ctrl+Shift+-" : "actionShrinken",
        "Ctrl++" : "actionZoom_In",
        "Ctrl+-" : "actionZoom_Out",
        "F1" : "actionSmall_Terminal",

        #Container
        #"Alt+Shift+Page Up" : "actionDelete_Current_Track",
        #"Alt+Shift+Page Down" : "actionAdd_Track",
        "Alt+Page Up" : "actionMove_Track_Up",
        "Alt+Page Down" : "actionMove_Track_Down",
        "Alt+V, 1":"actionVoiceOne",
        "Alt+V, 2":"actionVoiceTwo",
        "Alt+V, 3":"actionVoiceThree",
        "Alt+V, 4":"actionVoiceFour",
        "Alt+V, 0":"actionVoiceAutomatic",

        #
        "Alt+Return" : "actionEdit_Current_Object",
        "T" : "actionTriplet",
        "Alt+T" : "actionCustom_Tuplet",
        "D" : "actionAugment",
        "A" : "actionDiminish",
        "." : "actionAdd_Dot",
        "Shift+." : "actionRemove_Dot",
        "Alt+." : "actionToggle_Prevailing_Dot",
        "Alt+M" : "actionMultiMeasureRest",
        "M" : "actionFullMeasureRest",
        "Shift+T" : "actionClear_Tuplets",
        "F" : "actionFermata",
        "B" : "actionBeam_Start",
        "Shift+B" : "actionBeam_End",
        "G" : "actionSlur_Start_On_Off",
        "Shift+G" : "actionSlur_End_On_Off",
        "C" : "actionEdit_Chord_Symbol",
        "Shift+C" : "actionClear_Chord_Symbol",
        "Alt+C" : "actionMass_Insert_Chord_Symbols",
        "P" : "actionEdit_Figured_Bass",
        "Shift+P" : "actionClear_Figured_Bass",
        "Alt+P" : "actionMass_Insert_Figured_Bass",
        "Q" : "actionSplit_in_Two",
        "Shift+Q" : "actionSplit_in_Three",
        "Alt+Q" : "actionCustom_Split",
        "I" : "actionTie_One_Note_On_Off",
        "U" : "actionUpbeat",
        "R" : "actionTrill",
        "," : "actionStaccato",
        "_" : "actionTenuto",
        "x" : "actionFree_Text",
        "j" : "actionJoin_to_Cursor",
        "Shift+j" : "actionJoin_to_Chord",
        "z" : "actionSustain_Change_non_print",
        "Shift+z" : "action_Sustain_On",
        "Alt+z" : "action_Sustain_Off",
        "Alt+E" : "actionFull_Dual_Ending_Sequence",

                #Fingerings
        "Alt+F, Space" : "actionClear_All_Fingerings",
        "Alt+F, 0" : "actionFinger_0",
        "Alt+F, 1" : "actionFinger_1",
        "Alt+F, 2" : "actionFinger_2",
        "Alt+F, 3" : "actionFinger_3",
        "Alt+F, 4" : "actionFinger_4",
        "Alt+F, 5" : "actionFinger_5",
        "Alt+F, 6" : "actionCustom_Finger",

        #Dynamics
        "Alt+D, 1" : "actionPianissimo",
        "Alt+D, 2" : "actionPiano",
        "Alt+D, 3" : "actionMezzo_forte",
        "Alt+D, 4" : "actionForte",
        "Alt+D, 5" : "actionFortissimo",


        #Barlines
        "Alt+B,1" : "actionDouble",
        "Alt+B,2" : "actionRepeat_Open",
        "Alt+B,3" : "actionRepeat_Close",
        "Alt+B,4" : "actionRepeat_Close_Open",


        #Advanced
        "#" : "actionChannel_Plus",
        "Shift+#" : "actionChannel_Minus",
        "Alt+#" : "actionChannel_Force",
        "Alt+Shift+#" : "actionChannel_Clear",

        ">" : "actionChord_Duration_Factor_Plus",
        "<" : "actionChord_Duration_Factor_Minus",
        "Alt+<" : "actionChord_Duration_Factor_Reset",

        "Shift+v" : "actionChord_Velocity_Factor_Plus",
        "v" : "actionChord_Velocity_Factor_Minus",
        "Alt+v" : "actionChord_Velocity_Factor_Reset",

        }

#Add an action to the toolbar
toolbar = {
        #"titleString":"actionName",
}

#Load a personal config file which can overide the default config.
def reloadPersonalConfig():
    """It is important to execute this function before any other gui
    functions like generating toolbars or user menus."""
    try:
        f = open(api._getConfigDir() + "laborejo-qt.config")
        extras = compile(f.read(), '<string>', 'exec')
        f.close()
        exec(extras, locals(), globals()) #override the existing variables.
    except:
        pass #personal config file does not exist
