# -*- coding: utf-8 -*-
import laborejocore as api
class Commands(object):
    """Change _key_x, not the function:
    Qt shortcuts do not hold a reference to a function but it copies
    the function content. So we need an additional step in between which
    can be re-defined. Putting the api. methods directly into
    key_one(self) will work but is unchangable."""
    def __init__(self):
        self.defaults()

    def defaults(self):
        self._key_one = api.insert1
        self._key_two = api.insert2
        self._key_three = api.insert4
        self._key_four = api.insert8
        self._key_five = api.insert16
        self._key_six = api.insert32
        self._key_seven = api.insertBreve
        self._key_eight = api.insertLonga
        self._key_nine = api.nothing
        self._key_zero = api.nothing

        self._key_shift_one = api.insertRest1
        self._key_shift_two = api.insertRest2
        self._key_shift_three = api.insertRest4
        self._key_shift_four = api.insertRest8
        self._key_shift_five = api.insertRest16
        self._key_shift_six = api.insertRest32
        self._key_shift_seven = api.insertRestBreve
        self._key_shift_eight = api.insertRestLonga
        self._key_shift_nine = api.nothing
        self._key_shift_zero = api.nothing

        #self._key_alt_one = api.prevailing1
        #self._key_alt_two = api.prevailing2
        #self._key_alt_three = api.prevailing4
        #self._key_alt_four = api.prevailing8
        #self._key_alt_five = api.prevailing16
        #self._key_alt_six = api.prevailing32
        #self._key_alt_seven = api.prevailingBreve
        #self._key_alt_eight = api.prevailingLonga
        #self._key_alt_nine = api.nothing
        #self._key_alt_zero = api.nothing

        self._key_alt_shift_one = api.insertSkip1
        self._key_alt_shift_two = api.insertSkip2
        self._key_alt_shift_three = api.insertSkip4
        self._key_alt_shift_four = api.insertSkip8
        self._key_alt_shift_five = api.insertSkip16
        self._key_alt_shift_six = api.insertSkip32
        self._key_alt_shift_seven = api.insertSkipBreve
        self._key_alt_shift_eight = api.insertSkipLonga
        self._key_alt_shift_nine = api.nothing
        self._key_alt_shift_zero = api.nothing

        ##Keypad Commands. Choose the cursor position.

        #Clef-Nearest C octave
        self._keypad_one = lambda: api.toRelativeScalePosition(0) #c
        self._keypad_two = lambda: api.toRelativeScalePosition(1) #d
        self._keypad_three = lambda: api.toRelativeScalePosition(2) #e
        self._keypad_four = lambda: api.toRelativeScalePosition(3) #f
        self._keypad_five = lambda: api.toRelativeScalePosition(4) #g
        self._keypad_six = lambda: api.toRelativeScalePosition(5) #a
        self._keypad_seven = lambda: api.toRelativeScalePosition(6) #b
        self._keypad_eight = lambda: api.toRelativeScalePosition(7) #c'
        self._keypad_nine = lambda: api.toRelativeScalePosition(8) #d'
        self._keypad_zero = lambda: api.toRelativeScalePosition(-1) #b,

        #One octave higher
        self._keypad_shift_one = lambda: api.toRelativeScalePosition(0+7) #c'
        self._keypad_shift_two = lambda: api.toRelativeScalePosition(1+7) #d'
        self._keypad_shift_three = lambda: api.toRelativeScalePosition(2+7) #e'
        self._keypad_shift_four = lambda: api.toRelativeScalePosition(3+7) #f'
        self._keypad_shift_five = lambda: api.toRelativeScalePosition(4+7) #g'
        self._keypad_shift_six = lambda: api.toRelativeScalePosition(5+7) #a'
        self._keypad_shift_seven = lambda: api.toRelativeScalePosition(6+7) #b'
        self._keypad_shift_eight = lambda: api.toRelativeScalePosition(7+7) #c''
        self._keypad_shift_nine = lambda: api.toRelativeScalePosition(8+7) #d''
        self._keypad_shift_zero = lambda: api.toRelativeScalePosition(-1+7) #b

        #One octave lower
        self._keypad_ctrl_one = lambda: api.toRelativeScalePosition(0-7) #c,
        self._keypad_ctrl_two = lambda: api.toRelativeScalePosition(1-7) #d,
        self._keypad_ctrl_three = lambda: api.toRelativeScalePosition(2-7) #e,
        self._keypad_ctrl_four = lambda: api.toRelativeScalePosition(3-7) #f,
        self._keypad_ctrl_five = lambda: api.toRelativeScalePosition(4-7) #g,
        self._keypad_ctrl_six = lambda: api.toRelativeScalePosition(5-7) #a,
        self._keypad_ctrl_seven = lambda: api.toRelativeScalePosition(6-7) #b,
        self._keypad_ctrl_eight = lambda: api.toRelativeScalePosition(7-7) #c
        self._keypad_ctrl_nine = lambda: api.toRelativeScalePosition(8-7) #d
        self._keypad_ctrl_zero = lambda: api.toRelativeScalePosition(-1-7) #b,,

        #Add Chordnote to Clef-Nearest C octave
        self._keypad_alt_one = lambda: api.addScalePositionToChord(0) #c
        self._keypad_alt_two = lambda: api.addScalePositionToChord(1) #d
        self._keypad_alt_three = lambda: api.addScalePositionToChord(2) #e
        self._keypad_alt_four = lambda: api.addScalePositionToChord(3) #f
        self._keypad_alt_five = lambda: api.addScalePositionToChord(4) #g
        self._keypad_alt_six = lambda: api.addScalePositionToChord(5) #a
        self._keypad_alt_seven = lambda: api.addScalePositionToChord(6) #b
        self._keypad_alt_eight = lambda: api.addScalePositionToChord(7) #c'
        self._keypad_alt_nine = lambda: api.addScalePositionToChord(8) #d'
        self._keypad_alt_zero = lambda: api.addScalePositionToChord(-1) #b,

        #Add Chordnote to One octave higher
        self._keypad_alt_shift_one = lambda: api.addScalePositionToChord(0+7) #c'
        self._keypad_alt_shift_two = lambda: api.addScalePositionToChord(1+7) #d'
        self._keypad_alt_shift_three = lambda: api.addScalePositionToChord(2+7) #e'
        self._keypad_alt_shift_four = lambda: api.addScalePositionToChord(3+7) #f'
        self._keypad_alt_shift_five = lambda: api.addScalePositionToChord(4+7) #g'
        self._keypad_alt_shift_six = lambda: api.addScalePositionToChord(5+7) #a'
        self._keypad_alt_shift_seven = lambda: api.addScalePositionToChord(6+7) #b'
        self._keypad_alt_shift_eight = lambda: api.addScalePositionToChord(7+7) #c''
        self._keypad_alt_shift_nine = lambda: api.addScalePositionToChord(8+7) #d''
        self._keypad_alt_shift_zero = lambda: api.addScalePositionToChord(-1+7) #b

        #Add Chordnote to One octave lower
        self._keypad_alt_ctrl_one = lambda: api.addScalePositionToChord(0-7) #c,
        self._keypad_alt_ctrl_two = lambda: api.addScalePositionToChord(1-7) #d,
        self._keypad_alt_ctrl_three = lambda: api.addScalePositionToChord(2-7) #e,
        self._keypad_alt_ctrl_four = lambda: api.addScalePositionToChord(3-7) #f,
        self._keypad_alt_ctrl_five = lambda: api.addScalePositionToChord(4-7) #g,
        self._keypad_alt_ctrl_six = lambda: api.addScalePositionToChord(5-7) #a,
        self._keypad_alt_ctrl_seven = lambda: api.addScalePositionToChord(6-7) #b,
        self._keypad_alt_ctrl_eight = lambda: api.addScalePositionToChord(7-7) #c
        self._keypad_alt_ctrl_nine = lambda: api.addScalePositionToChord(8-7) #d
        self._keypad_alt_ctrl_zero = lambda: api.addScalePositionToChord(-1-7) #b,,

    def prevailing(self):
        self._key_one = api.prevailing1
        self._key_two = api.prevailing2
        self._key_three = api.prevailing4
        self._key_four = api.prevailing8
        self._key_five = api.prevailing16
        self._key_six = api.prevailing32
        self._key_seven = api.prevailingBreve
        self._key_eight = api.prevailingLonga

        ##Keypad Commands. Insert a scale Position.

        #Clef-Nearest C octave
        self._keypad_one = lambda: api.insertPrevailingScalePosition(0) #c
        self._keypad_two = lambda: api.insertPrevailingScalePosition(1) #d
        self._keypad_three = lambda: api.insertPrevailingScalePosition(2) #e
        self._keypad_four = lambda: api.insertPrevailingScalePosition(3) #f
        self._keypad_five = lambda: api.insertPrevailingScalePosition(4) #g
        self._keypad_six = lambda: api.insertPrevailingScalePosition(5) #a
        self._keypad_seven = lambda: api.insertPrevailingScalePosition(6) #b
        self._keypad_eight = lambda: api.insertPrevailingScalePosition(7) #c'
        self._keypad_nine = lambda: api.insertPrevailingScalePosition(8) #d'
        self._keypad_zero = lambda: api.insertPrevailingScalePosition(-1) #b,

        #One octave higher
        self._keypad_shift_one = lambda: api.insertPrevailingScalePosition(0+7) #c'
        self._keypad_shift_two = lambda: api.insertPrevailingScalePosition(1+7) #d'
        self._keypad_shift_three = lambda: api.insertPrevailingScalePosition(2+7) #e'
        self._keypad_shift_four = lambda: api.insertPrevailingScalePosition(3+7) #f'
        self._keypad_shift_five = lambda: api.insertPrevailingScalePosition(4+7) #g'
        self._keypad_shift_six = lambda: api.insertPrevailingScalePosition(5+7) #a'
        self._keypad_shift_seven = lambda: api.insertPrevailingScalePosition(6+7) #b'
        self._keypad_shift_eight = lambda: api.insertPrevailingScalePosition(7+7) #c''
        self._keypad_shift_nine = lambda: api.insertPrevailingScalePosition(8+7) #d''
        self._keypad_shift_zero = lambda: api.insertPrevailingScalePosition(-1+7) #b

        #One octave lower
        self._keypad_ctrl_one = lambda: api.insertPrevailingScalePosition(0-7) #c,
        self._keypad_ctrl_two = lambda: api.insertPrevailingScalePosition(1-7) #d,
        self._keypad_ctrl_three = lambda: api.insertPrevailingScalePosition(2-7) #e,
        self._keypad_ctrl_four = lambda: api.insertPrevailingScalePosition(3-7) #f,
        self._keypad_ctrl_five = lambda: api.insertPrevailingScalePosition(4-7) #g,
        self._keypad_ctrl_six = lambda: api.insertPrevailingScalePosition(5-7) #a,
        self._keypad_ctrl_seven = lambda: api.insertPrevailingScalePosition(6-7) #b,
        self._keypad_ctrl_eight = lambda: api.insertPrevailingScalePosition(7-7) #c
        self._keypad_ctrl_nine = lambda: api.insertPrevailingScalePosition(8-7) #d
        self._keypad_ctrl_zero = lambda: api.insertPrevailingScalePosition(-1-7) #b,,


    #Do not change these:
    def key_one(self): self._key_one()
    def key_two(self): self._key_two()
    def key_three(self): self._key_three()
    def key_four(self): self._key_four()
    def key_five(self): self._key_five()
    def key_six(self): self._key_six()
    def key_seven(self): self._key_seven()
    def key_eight(self): self._key_eight()
    def key_nine(self): self._key_nine()
    def key_zero(self): self._key_zero()

    def key_shift_one(self): self._key_shift_one()
    def key_shift_two(self): self._key_shift_two()
    def key_shift_three(self): self._key_shift_three()
    def key_shift_four(self): self._key_shift_four()
    def key_shift_five(self): self._key_shift_five()
    def key_shift_six(self): self._key_shift_six()
    def key_shift_seven(self): self._key_shift_seven()
    def key_shift_eight(self): self._key_shift_eight()
    def key_shift_nine(self): self._key_shift_nine()
    def key_shift_zero(self): self._key_shift_zero()

    #def key_alt_one(self): self._key_alt_one()
    #def key_alt_two(self): self._key_alt_two()
    #def key_alt_three(self): self._key_alt_three()
    #def key_alt_four(self): self._key_alt_four()
    #def key_alt_five(self): self._key_alt_five()
    #def key_alt_six(self): self._key_alt_six()
    #def key_alt_seven(self): self._key_alt_seven()
    #def key_alt_eight(self): self._key_alt_eight()
    #def key_alt_nine(self): self._key_alt_nine()
    #def key_alt_zero(self): self._key_alt_zero()

    def key_alt_shift_one(self): self._key_alt_shift_one()
    def key_alt_shift_two(self): self._key_alt_shift_two()
    def key_alt_shift_three(self): self._key_alt_shift_three()
    def key_alt_shift_four(self): self._key_alt_shift_four()
    def key_alt_shift_five(self): self._key_alt_shift_five()
    def key_alt_shift_six(self): self._key_alt_shift_six()
    def key_alt_shift_seven(self): self._key_alt_shift_seven()
    def key_alt_shift_eight(self): self._key_alt_shift_eight()
    def key_alt_shift_nine(self): self._key_alt_shift_nine()
    def key_alt_shift_zero(self): self._key_alt_shift_zero()

    #Keypad commands
    def keypad_one(self): self._keypad_one()
    def keypad_two(self): self._keypad_two()
    def keypad_three(self): self._keypad_three()
    def keypad_four(self): self._keypad_four()
    def keypad_five(self): self._keypad_five()
    def keypad_six(self): self._keypad_six()
    def keypad_seven(self): self._keypad_seven()
    def keypad_eight(self): self._keypad_eight()
    def keypad_nine(self): self._keypad_nine()
    def keypad_zero(self): self._keypad_zero()

    def keypad_shift_one(self): self._keypad_shift_one()
    def keypad_shift_two(self): self._keypad_shift_two()
    def keypad_shift_three(self): self._keypad_shift_three()
    def keypad_shift_four(self): self._keypad_shift_four()
    def keypad_shift_five(self): self._keypad_shift_five()
    def keypad_shift_six(self): self._keypad_shift_six()
    def keypad_shift_seven(self): self._keypad_shift_seven()
    def keypad_shift_eight(self): self._keypad_shift_eight()
    def keypad_shift_nine(self): self._keypad_shift_nine()
    def keypad_shift_zero(self): self._keypad_shift_zero()

    def keypad_ctrl_one(self): self._keypad_ctrl_one()
    def keypad_ctrl_two(self): self._keypad_ctrl_two()
    def keypad_ctrl_three(self): self._keypad_ctrl_three()
    def keypad_ctrl_four(self): self._keypad_ctrl_four()
    def keypad_ctrl_five(self): self._keypad_ctrl_five()
    def keypad_ctrl_six(self): self._keypad_ctrl_six()
    def keypad_ctrl_seven(self): self._keypad_ctrl_seven()
    def keypad_ctrl_eight(self): self._keypad_ctrl_eight()
    def keypad_ctrl_nine(self): self._keypad_ctrl_nine()
    def keypad_ctrl_zero(self): self._keypad_ctrl_zero()

    #Keypad Alt commands
    def keypad_alt_one(self): self._keypad_alt_one()
    def keypad_alt_two(self): self._keypad_alt_two()
    def keypad_alt_three(self): self._keypad_alt_three()
    def keypad_alt_four(self): self._keypad_alt_four()
    def keypad_alt_five(self): self._keypad_alt_five()
    def keypad_alt_six(self): self._keypad_alt_six()
    def keypad_alt_seven(self): self._keypad_alt_seven()
    def keypad_alt_eight(self): self._keypad_alt_eight()
    def keypad_alt_nine(self): self._keypad_alt_nine()
    def keypad_alt_zero(self): self._keypad_alt_zero()

    def keypad_alt_shift_one(self): self._keypad_alt_shift_one()
    def keypad_alt_shift_two(self): self._keypad_alt_shift_two()
    def keypad_alt_shift_three(self): self._keypad_alt_shift_three()
    def keypad_alt_shift_four(self): self._keypad_alt_shift_four()
    def keypad_alt_shift_five(self): self._keypad_alt_shift_five()
    def keypad_alt_shift_six(self): self._keypad_alt_shift_six()
    def keypad_alt_shift_seven(self): self._keypad_alt_shift_seven()
    def keypad_alt_shift_eight(self): self._keypad_alt_shift_eight()
    def keypad_alt_shift_nine(self): self._keypad_alt_shift_nine()
    def keypad_alt_shift_zero(self): self._keypad_alt_shift_zero()

    def keypad_alt_ctrl_one(self): self._keypad_alt_ctrl_one()
    def keypad_alt_ctrl_two(self): self._keypad_alt_ctrl_two()
    def keypad_alt_ctrl_three(self): self._keypad_alt_ctrl_three()
    def keypad_alt_ctrl_four(self): self._keypad_alt_ctrl_four()
    def keypad_alt_ctrl_five(self): self._keypad_alt_ctrl_five()
    def keypad_alt_ctrl_six(self): self._keypad_alt_ctrl_six()
    def keypad_alt_ctrl_seven(self): self._keypad_alt_ctrl_seven()
    def keypad_alt_ctrl_eight(self): self._keypad_alt_ctrl_eight()
    def keypad_alt_ctrl_nine(self): self._keypad_alt_ctrl_nine()
    def keypad_alt_ctrl_zero(self): self._keypad_alt_ctrl_zero()

commands = Commands()
